// AddLoginDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "VaxTeleConfigDlg.h"
#include "AddLoginDlg.h"
#include "Codec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddLoginDlg dialog


CAddLoginDlg::CAddLoginDlg() : CPropertyPage(CAddLoginDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddLoginDlg)
	m_sPasswordSIP = _T("");
	m_bAccountBlocked = FALSE;
	m_sLoginSIP = _T("");
	m_bStealthListener = FALSE;
	//}}AFX_DATA_INIT

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}


void CAddLoginDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddLoginDlg)
	DDX_Control(pDX, IDC_COMBO_LOGIN, m_ctrlComboLogin);
	DDX_Control(pDX, IDC_LIST_ENABLE_CODEC, m_ctrlEnableCodecList);
	DDX_Control(pDX, IDC_LIST_DISABLE_CODEC, m_ctrlDisableCodecList);
	DDX_Text(pDX, IDC_EDIT_PWD_SIP, m_sPasswordSIP);
	DDX_Check(pDX, IDC_CHECK_BLOCK_ACCOUNT, m_bAccountBlocked);
	DDX_CBString(pDX, IDC_COMBO_LOGIN, m_sLoginSIP);
	DDX_Check(pDX, IDC_CHECK_STEALTH_LISTENER, m_bStealthListener);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddLoginDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddLoginDlg)
	ON_BN_CLICKED(IDC_BUTTON_LOGIN_ADD, OnButtonLoginAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_LOGIN, OnButtonRemoveLogin)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_CODEC, OnButtonEnableCodec)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE_CODEC, OnButtonDisableCodec)
	ON_CBN_SELCHANGE(IDC_COMBO_LOGIN, OnSelchangeComboLogin)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_LOGIN_HELP, OnButtonLoginHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddLoginDlg message handlers

BOOL CAddLoginDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ctrlComboLogin.SetWindowPos(NULL,0,0,160,150,SWP_NOMOVE|SWP_NOZORDER);
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("ShowUsers", NULL);

	ClearDlgContent();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddLoginDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "ShowUsers") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objLogin = pParamList->GetAt(pParamList->FindIndex(nCount));
			m_ctrlComboLogin.AddString(objLogin);
		}

		return;
	}

	if(::lstrcmpi(sCommand, "UserInfo") == 0 && pParamList->GetCount() == 5)
	{
		CString objLogin     = pParamList->GetAt(pParamList->FindIndex(0));
		CString objPassword  = pParamList->GetAt(pParamList->FindIndex(1));
		CString objCodecList = pParamList->GetAt(pParamList->FindIndex(2));
		CString objStealth   = pParamList->GetAt(pParamList->FindIndex(3));
		CString objBlock     = pParamList->GetAt(pParamList->FindIndex(4));
				
		UpdateDlgContent(objLogin, objPassword, objCodecList, objStealth, objBlock);

		return;
	}

	if(::lstrcmpi(sCommand, "RemoveUser") == 0 && pParamList->GetCount() == 1)
	{
		int nIndex = m_ctrlComboLogin.FindStringExact(0, pParamList->GetHead());
		
		if(nIndex != -1)
			m_ctrlComboLogin.DeleteString(nIndex);
	
		MessageBox("Login removed successfully!", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		ClearDlgContent();

		return;
	}

	if(::lstrcmpi(sCommand, "AddUser") == 0 && pParamList->GetCount() == 1)
	{
		CString objLogin = pParamList->GetHead();
		m_ctrlComboLogin.AddString(objLogin);

		MessageBox("Login created successfully", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateUser") == 0 && pParamList->GetCount() == 1)
	{
		MessageBox("Login updated successfully", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}
}

void CAddLoginDlg::OnButtonLoginAdd() 
{
	UpdateData();

	if(!AddLoginChecks())
		return;
		
	if(m_ctrlComboLogin.FindStringExact(0, m_sLoginSIP) != -1)
	{
		if(MessageBox("Login already exist, do you want to update it?", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_YESNO) == IDNO)
			return;
	}

	CStringList objParamList;
	
	CCodec objCodec;
	CString objCodecParam;
	
	for(int nCount = 0; nCount < m_ctrlEnableCodecList.GetCount(); nCount++)
	{
		CString sCodecText;
		m_ctrlEnableCodecList.GetText(nCount, sCodecText);

		objCodecParam += objCodec.GetCodecNo(sCodecText);
	}

	objParamList.AddTail(m_sLoginSIP);
	objParamList.AddTail(m_sPasswordSIP);
	objParamList.AddTail(objCodecParam);
	
	if(m_bStealthListener)
		objParamList.AddTail("STEALTH-YES");
	else
		objParamList.AddTail("STEALTH-NO");
	
	if(m_bAccountBlocked)
		objParamList.AddTail("BLOCK-YES");
	else
		objParamList.AddTail("BLOCK-NO");
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("AddUser", &objParamList);
	
}

void CAddLoginDlg::OnButtonRemoveLogin() 
{
	UpdateData();
	
	if(m_sLoginSIP.IsEmpty())
	{
		MessageBox("Please enter login.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	CStringList objParamList;
	objParamList.AddTail(m_sLoginSIP);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("RemoveUser", &objParamList);
}


void CAddLoginDlg::OnButtonEnableCodec() 
{
	int nCurSel = m_ctrlDisableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	
	m_ctrlDisableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlDisableCodecList.DeleteString(nCurSel);
	
	m_ctrlEnableCodecList.AddString(sCurSelText);
}

void CAddLoginDlg::OnButtonDisableCodec() 
{
	int nCurSel = m_ctrlEnableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	m_ctrlEnableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlEnableCodecList.DeleteString(nCurSel);
	
	m_ctrlDisableCodecList.AddString(sCurSelText);
}


BOOL CAddLoginDlg::AddLoginChecks()
{
	if(m_sLoginSIP.IsEmpty())
	{
		MessageBox("Please enter login.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
	
	CString sDigits = "0123456789";
	for(int nIndex = 0; nIndex < m_sLoginSIP.GetLength(); nIndex++)
	{
		if(sDigits.Find(m_sLoginSIP.GetAt(nIndex)) == -1)
		{
			MessageBox("Login should contain only numerals 0 through 9.\n\nFor example: 12 or 324323 or 800122 or 2109756 etc.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
			return FALSE;
		}
	}

	if(m_sPasswordSIP.IsEmpty())
	{
		MessageBox("Please enter login password.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
		
	if(m_sLoginSIP.GetLength() > 20 || m_sPasswordSIP.GetLength() > 20)
	{
		MessageBox("Login and password size should not be more 20.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(m_sLoginSIP.Left(2) == "00")
	{
		MessageBox("Please donot enter 00 as login prefix. 00 prefix is use to prepare dial plan.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(m_ctrlEnableCodecList.GetCount() == 0)
	{
		MessageBox("Please select a codec.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	return TRUE;
}


void CAddLoginDlg::ClearDlgContent()
{
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	m_ctrlEnableCodecList.AddString(G711U_TEXT);
	m_ctrlEnableCodecList.AddString(G711A_TEXT);
	m_ctrlEnableCodecList.AddString(ILBC_TEXT);
	m_ctrlEnableCodecList.AddString(G610_TEXT);
	m_ctrlEnableCodecList.AddString(G729_TEXT);

	m_sLoginSIP    = "";
	m_sPasswordSIP = "";
		
	m_bAccountBlocked = FALSE;
	m_bStealthListener = FALSE;

	UpdateData(FALSE);
}


void CAddLoginDlg::OnSelchangeComboLogin() 
{
	int nCurIndex = m_ctrlComboLogin.GetCurSel();
	if(nCurIndex == -1) return;

	m_ctrlComboLogin.GetLBText(nCurIndex, m_sLoginSIP);
		
	CStringList objParamList;
	objParamList.AddTail(m_sLoginSIP);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("UserInfo", &objParamList);
	
}

void CAddLoginDlg::UpdateDlgContent(LPCTSTR sLogin, LPCTSTR sPassword, CString objCodecList, CString objStealth, CString objBlock) 
{
	UpdateData();

	if(m_sLoginSIP != sLogin) return;

	m_sPasswordSIP = sPassword;

	CCodec objCodec;
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(char cCodec = '0'; cCodec < TOTAL_NO_CODEC; cCodec++)	
		m_ctrlDisableCodecList.AddString(objCodec.GetCodecName(cCodec));
	
	for(int nCount = 0; nCount < objCodecList.GetLength(); nCount++)
	{
		CString sCodecName = objCodec.GetCodecName(objCodecList.GetAt(nCount));
		m_ctrlEnableCodecList.AddString(sCodecName);
		
		int nIndex = m_ctrlDisableCodecList.FindStringExact(0, sCodecName);
		if(nIndex == -1) continue;
		
		m_ctrlDisableCodecList.DeleteString(nIndex);
	}
		
	m_bStealthListener = (objStealth.Find("STEALTH-YES") != -1);
	m_bAccountBlocked  = (objBlock.Find("BLOCK-YES") != -1);

	UpdateData(FALSE);
}

void CAddLoginDlg::OnButtonClear() 
{
	ClearDlgContent();
}

void CAddLoginDlg::OnButtonLoginHelp() 
{
	
}
