// TelnetCmd.cpp: implementation of the CTelnetCmd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSIP.h"
#include "TelnetCmd.h"
#include "Registry.h"
#include "TelnetClient.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTelnetCmd::CTelnetCmd()
{

}

CTelnetCmd::~CTelnetCmd()
{

}


void CTelnetCmd::ShowUsers(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;

	CStringList objLoginList;
	objReg.EnumLogin(&objLoginList);

	pTelnetClient->SendCommand("ShowUsers", &objLoginList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::UserInfo(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objLogin = pParamList->GetHead();
		
	CRegistry objReg;
	CLoginReg objLoginReg;
		
	if(!objReg.GetLogin(objLogin, &objLoginReg))
	{
		CStringList objParamList;
		objParamList.AddTail("User not found.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}
	
	CStringList objParamList;
	objParamList.AddTail(objLogin);
	objParamList.AddTail(objLoginReg.m_sPassword);
	objParamList.AddTail(objLoginReg.m_sCodec);
	
	if(objLoginReg.m_bStealth)
		objParamList.AddTail("STEALTH-YES");
	else
		objParamList.AddTail("STEALTH-NO");

	if(objLoginReg.m_bBlock)
		objParamList.AddTail("BLOCK-YES");
	else
		objParamList.AddTail("BLOCK-NO");

	pTelnetClient->SendCommand("UserInfo", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::AddUser(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objLogin = pParamList->GetAt(pParamList->FindIndex(0));

	CRegistry objReg;
	CLoginReg objLoginReg;
	
	objLoginReg.m_sPassword = pParamList->GetAt(pParamList->FindIndex(1));
	objLoginReg.m_sCodec    = pParamList->GetAt(pParamList->FindIndex(2));
	
	objLoginReg.m_bStealth  = (pParamList->GetAt(pParamList->FindIndex(3)) == "STEALTH-YES");
	objLoginReg.m_bBlock    = (pParamList->GetAt(pParamList->FindIndex(4)) == "BLOCK-YES");

	BOOL bUpdate = objReg.IsLoginExist(objLogin);
	
	if(!objReg.SetLogin(objLogin, &objLoginReg))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to add user.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CStringList objParamList;
	objParamList.AddTail(objLogin);
	
	if(bUpdate)
		pTelnetClient->SendCommand("UpdateUser", &objParamList);
	else
		pTelnetClient->SendCommand("AddUser", &objParamList);

	pTelnetClient->SendText("VaxTele:>");
}


void CTelnetCmd::RemoveUser(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objLogin = pParamList->GetAt(pParamList->FindIndex(0));

	CRegistry objReg;
	if(!objReg.RemoveLogin(objLogin))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to remove user.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CStringList objParamList;
	objParamList.AddTail(objLogin);
	
	pTelnetClient->SendCommand("RemoveUser", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}


/**********************************************/

void CTelnetCmd::ShowQueues(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;

	CStringList objQueueList;
	objReg.EnumQueue(&objQueueList);

	pTelnetClient->SendCommand("ShowQueues", &objQueueList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::QueueInfo(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objQueue = pParamList->GetHead();
		
	CRegistry objReg;
	CQueueReg objQueueReg;
	CStringList objParamList;
	
	if(!objReg.GetQueue(objQueue, &objQueueReg))
	{
		objParamList.AddTail("Queue not found.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}
	
	objParamList.AddTail(objQueue);
	objParamList.AddTail(objQueueReg.m_sPlayWave);
	objParamList.AddTail(objQueueReg.m_sPressDigitPlayWave);
	
	////////////////////////////////////////////

	CString objQueueOPList;

	PrepareToStr(&objQueueReg.m_objQueueOPList, objQueueOPList);
	objParamList.AddTail(objQueueOPList);
	
	////////////////////////////////////////////
	
	CString objPressDigitList;
	
	PrepareToStr(&objQueueReg.m_objPressDigitList, objPressDigitList);
	objParamList.AddTail(objPressDigitList);

	////////////////////////////////////////////

	CString objPressDigitUserList;

	PrepareToStr(&objQueueReg.m_objPressDigitUserList, objPressDigitUserList);
	objParamList.AddTail(objPressDigitUserList);

	////////////////////////////////////////////
	
	pTelnetClient->SendCommand("QueueInfo", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

void CTelnetCmd::AddQueue(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objQueueName = pParamList->GetAt(pParamList->FindIndex(0));
	
	///////////////////////////////////////

	BOOL bUpdate = (CServerSIP::m_pServerSIP->m_objQueueList.FindQueue(objQueueName) != NULL);

	///////////////////////////////////////

	CString objPlayWave           = pParamList->GetAt(pParamList->FindIndex(1));
	CString objPressDigitPlayWave = pParamList->GetAt(pParamList->FindIndex(2));
	
	///////////////////////////////////////
	
	CStringList objQueueOPList;
	ParseToList(pParamList->GetAt(pParamList->FindIndex(3)), &objQueueOPList);
		
	///////////////////////////////////////
		
	CStringList objPressDigitList;
	ParseToList(pParamList->GetAt(pParamList->FindIndex(4)), &objPressDigitList);
				
	///////////////////////////////////////
	
	CStringList objPressDigitUserList;
	ParseToList(pParamList->GetAt(pParamList->FindIndex(5)), &objPressDigitUserList);
		
	///////////////////////////////////////
		
	if(!CServerSIP::m_pServerSIP->m_objQueueList.AddQueue(objQueueName, objPlayWave, objPressDigitPlayWave, &objQueueOPList, &objPressDigitList, &objPressDigitUserList))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to add queue.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CStringList objParamList;
	objParamList.AddTail(objQueueName);
	
	if(bUpdate)
		pTelnetClient->SendCommand("UpdateQueue", &objParamList);
	else
		pTelnetClient->SendCommand("AddQueue", &objParamList);

	pTelnetClient->SendText("VaxTele:>");
}


void CTelnetCmd::RemoveQueue(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objQueueName = pParamList->GetAt(pParamList->FindIndex(0));

	if(!CServerSIP::m_pServerSIP->m_objQueueList.RemoveQueue(objQueueName))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to remove queue.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CStringList objParamList;
	objParamList.AddTail(objQueueName);
	
	pTelnetClient->SendCommand("RemoveQueue", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}

/**********************************************/

void CTelnetCmd::ShowLines(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;

	CStringList objLineList;
	objReg.EnumLine(&objLineList);

	pTelnetClient->SendCommand("ShowLines", &objLineList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::LineInfo(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objLine = pParamList->GetHead();
		
	CRegistry objReg;
	CLineReg objLineReg;
	CStringList objParamList;
	
	if(!objReg.GetLine(objLine, &objLineReg))
	{
		objParamList.AddTail("Line not found.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}
	
	objParamList.AddTail(objLine);

	objParamList.AddTail(objLineReg.m_sDisplayName);
	objParamList.AddTail(objLineReg.m_sUserName);
	objParamList.AddTail(objLineReg.m_sAuthUser);
	objParamList.AddTail(objLineReg.m_sPassword);
	objParamList.AddTail(objLineReg.m_sRealm);
	objParamList.AddTail(objLineReg.m_sProxy);
	objParamList.AddTail(objLineReg.m_sOutboundProxy);
	objParamList.AddTail(objLineReg.m_sCodec);

	if(objLineReg.m_bRegister)
		objParamList.AddTail("REGISTER-YES");
	else
		objParamList.AddTail("REGISTER-NO");


	objParamList.AddTail(objLineReg.m_sInCallType);
	objParamList.AddTail(objLineReg.m_sInCallTo);

	pTelnetClient->SendCommand("LineInfo", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}


void CTelnetCmd::AddLine(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objLineName    	= pParamList->GetAt(pParamList->FindIndex(0));
	CString sDisplayName	= pParamList->GetAt(pParamList->FindIndex(1));
	CString sUserName		= pParamList->GetAt(pParamList->FindIndex(2));
	CString sAuthUser		= pParamList->GetAt(pParamList->FindIndex(3));
	CString sAuthPwd		= pParamList->GetAt(pParamList->FindIndex(4));
	CString sRealm			= pParamList->GetAt(pParamList->FindIndex(5));
	CString sProxy			= pParamList->GetAt(pParamList->FindIndex(6));
	CString sOutboundProxy  = pParamList->GetAt(pParamList->FindIndex(7));
	CString sCodec			= pParamList->GetAt(pParamList->FindIndex(8));

	BOOL bRegister          = (pParamList->GetAt(pParamList->FindIndex(9)) == "REGISTER-YES");
		
	CString sInCallType     = pParamList->GetAt(pParamList->FindIndex(10));
	CString sInCallTo       = pParamList->GetAt(pParamList->FindIndex(11));

	BOOL bUpdate = (CServerSIP::m_pServerSIP->m_objLineList.FindLine(objLineName) != NULL);
	
	if(!CServerSIP::m_pServerSIP->m_objLineList.AddLine(objLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodec, bRegister, sInCallType, sInCallTo))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to add line.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CStringList objParamList;
	objParamList.AddTail(objLineName);
	
	if(bUpdate)
		pTelnetClient->SendCommand("UpdateLine", &objParamList);
	else
		pTelnetClient->SendCommand("AddLine", &objParamList);

	pTelnetClient->SendText("VaxTele:>");

}


void CTelnetCmd::RemoveLine(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objLineName = pParamList->GetHead();

	if(!CServerSIP::m_pServerSIP->m_objLineList.RemoveLine(objLineName))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to remove line.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CStringList objParamList;
	objParamList.AddTail(objLineName);
	
	pTelnetClient->SendCommand("RemoveLine", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
	
}

/**********************************************/

void CTelnetCmd::ShowDialPlans(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	
	CStringList objDialPlanList;
	objReg.EnumDialPlan(&objDialPlanList);

	CDialPlanReg objDialPlanReg;
	CStringList objParamList;

	while(!objDialPlanList.IsEmpty())
	{
		CString sUserPrefix = objDialPlanList.RemoveHead();
		objReg.GetDialPlan(sUserPrefix, &objDialPlanReg);

		if(objDialPlanReg.m_sCallPrefix.IsEmpty())
			objDialPlanReg.m_sCallPrefix = "None";
		
		objParamList.AddTail(sUserPrefix + "," + objDialPlanReg.m_sLineName + "," + objDialPlanReg.m_sCallPrefix);
	}

	pTelnetClient->SendCommand("ShowDialPlans", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::DialPlanInfo(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objUserPrefix = pParamList->GetHead();
		
	CRegistry objReg;
	CDialPlanReg objDialPlanReg;
	
	CStringList objParamList;

	if(!objReg.GetDialPlan(objUserPrefix, &objDialPlanReg))
	{
		objParamList.AddTail("DialPlan or user prefix not found.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	objParamList.AddTail(objUserPrefix);
	objParamList.AddTail(objDialPlanReg.m_sLineName);

	if(objDialPlanReg.m_sCallPrefix.IsEmpty())
		objDialPlanReg.m_sCallPrefix = "None";

	objParamList.AddTail(objDialPlanReg.m_sCallPrefix);

	pTelnetClient->SendCommand("DialPlanInfo", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
	
}

void CTelnetCmd::AddDialPlan(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objUserPrefix = pParamList->GetAt(pParamList->FindIndex(0));
		
	CRegistry objReg;
	CDialPlanReg objDialPlanReg;
	
	objDialPlanReg.m_sLineName   = pParamList->GetAt(pParamList->FindIndex(1));
	objDialPlanReg.m_sCallPrefix = pParamList->GetAt(pParamList->FindIndex(2));

	if(objDialPlanReg.m_sCallPrefix.CompareNoCase("none") == 0)
		objDialPlanReg.m_sCallPrefix = "";
	
	if(!objReg.SetDialPlan(objUserPrefix, &objDialPlanReg))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to add dialplan or user prefix.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CServerSIP::m_pServerSIP->m_objDialPlanList.ReLoadDialPlans();

	CStringList objParamList;

	objParamList.AddTail(objUserPrefix);
	objParamList.AddTail(objDialPlanReg.m_sLineName);

	if(objDialPlanReg.m_sCallPrefix.IsEmpty())
		objDialPlanReg.m_sCallPrefix = "None";

	objParamList.AddTail(objDialPlanReg.m_sCallPrefix);

	pTelnetClient->SendCommand("AddDialPlan", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::RemoveDialPlan(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objUserPrefix = pParamList->GetHead();
		
	CRegistry objReg;
	
	if(!objReg.RemoveDialPlan(objUserPrefix))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to remove dialplan or user prefix.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	CServerSIP::m_pServerSIP->m_objDialPlanList.ReLoadDialPlans();

	CStringList objParamList;
	objParamList.AddTail(objUserPrefix);
	
	pTelnetClient->SendCommand("RemoveDialPlan", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}

/*************************************************/

void CTelnetCmd::SetStealthMusic(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objStealthMusic = pParamList->GetHead();

	CRegistry objReg;
	CStringList objParamList;

	if(!objReg.SetStealthListenerMusic(objStealthMusic))
	{
		objParamList.AddTail("Unable to set stealth listener wave file.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	objParamList.AddTail(objStealthMusic);
	
	pTelnetClient->SendCommand("SetStealthMusic", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

void CTelnetCmd::GetStealthMusic(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	CStringList objParamList;

	objParamList.AddTail(objReg.GetStealthListenerMusic());
	
	pTelnetClient->SendCommand("GetStealthMusic", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

/*************************************************/

void CTelnetCmd::SetHoldMusic(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objHoldMusic = pParamList->GetHead();

	CRegistry objReg;
	CStringList objParamList;

	if(!objReg.SetHoldMusic(objHoldMusic))
	{
		objParamList.AddTail("Unable to set hold music wave file.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	objParamList.AddTail(objHoldMusic);
	
	pTelnetClient->SendCommand("SetHoldMusic", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

void CTelnetCmd::GetHoldMusic(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	CStringList objParamList;

	objParamList.AddTail(objReg.GetHoldMusic());
	
	pTelnetClient->SendCommand("GetHoldMusic", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

/*************************************************/

void CTelnetCmd::SetDialToneMusic(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CString objDialToneMusic = pParamList->GetHead();

	CRegistry objReg;
	CStringList objParamList;

	if(!objReg.SetDialToneMusic(objDialToneMusic))
	{
		objParamList.AddTail("Unable to set dial tone wave file.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	objParamList.AddTail(objDialToneMusic);
	
	pTelnetClient->SendCommand("SetDialToneMusic", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

void CTelnetCmd::GetDialToneMusic(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	CStringList objParamList;

	objParamList.AddTail(objReg.GetDialToneMusic());
	
	pTelnetClient->SendCommand("GetDialToneMusic", &objParamList);
	pTelnetClient->SendText("VaxTele:>");

}

/*************************************************/

void CTelnetCmd::GetCOMM(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	CDialPlanReg objDialPlanReg;
	
	CString objListenIP;    
	CString objListenPort;  
	CString objDominRealm; 
	
	CStringList objParamList;

	if(!objReg.GetCOMM(objListenIP, objListenPort, objDominRealm))
	{
		objParamList.AddTail("Unable to retrieve communication settings.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	objParamList.AddTail(objListenIP);
	objParamList.AddTail(objListenPort);
	objParamList.AddTail(objDominRealm);

	pTelnetClient->SendCommand("GetCOMM", &objParamList);
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::SetCOMM(CStringList* pParamList, CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	CDialPlanReg objDialPlanReg;
	
	CString objListenIP    = pParamList->GetAt(pParamList->FindIndex(0));
	CString objListenPort  = pParamList->GetAt(pParamList->FindIndex(1));
	CString objsDominRealm = pParamList->GetAt(pParamList->FindIndex(2));
	
	if(!objReg.SetCOMM(objListenIP, objListenPort, objsDominRealm))
	{
		CStringList objParamList;
		objParamList.AddTail("Unable to save communication settings.");
		
		pTelnetClient->SendCommand("MSG", &objParamList);
		pTelnetClient->SendText("VaxTele:>");

		return;
	}

	pTelnetClient->SendCommand("SetCOMM", pParamList);
	pTelnetClient->SendText("VaxTele:>");

}

///////////////////////////////////////////

void CTelnetCmd::StartServer(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	objReg.SetStartServer(TRUE);
	
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::StopServer(CTelnetClient* pTelnetClient)
{
	CRegistry objReg;
	objReg.SetStartServer(FALSE);
	
	pTelnetClient->SendText("VaxTele:>");
}

/////////////////////////////////////////

void CTelnetCmd::InvalidCommand(CTelnetClient* pTelnetClient)
{
	pTelnetClient->SendText("VaxTele:>");
}

void CTelnetCmd::ParseToList(CString sInputStr, CStringList* pOutputList)
{
    int nEnd = 0;

    while (sInputStr.GetLength() != 0)
    {
        nEnd = sInputStr.Find(",");

        if (nEnd == -1)
        {
            pOutputList->AddTail(sInputStr);
            break;
        }

        pOutputList->AddTail(sInputStr.Left(nEnd));
        sInputStr.Delete(0, nEnd + 1);
    }
}

void CTelnetCmd::PrepareToStr(CStringList* pInputList, CString& objOutputStr)
{
    objOutputStr = "";

	while(!pInputList->IsEmpty())
	{
		objOutputStr = objOutputStr + pInputList->RemoveHead() + ",";
	}

	if(!objOutputStr.IsEmpty())
			objOutputStr.Delete(objOutputStr.GetLength() - 1, 1);
}