using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VaxTeleConfigSIP
{
    public partial class GeneralForm : Form
    {
        public GeneralForm()
        {
            InitializeComponent();
        }

        public void OnTelnetCommand(string sCommand, ref ArrayList objParamList)
        {

            if (String.Compare(sCommand, "GetHoldMusic", true) == 0 && objParamList.Count == 1)
            {
                EditPlayWaveHold.Text = (string)objParamList[0];
                return;
            }

            if (String.Compare(sCommand, "GetDialToneMusic", true) == 0 && objParamList.Count == 1)
            {
                EditPlayWaveDialTone.Text = (string)objParamList[0];
                return;
            }

            if (String.Compare(sCommand, "GetStealthMusic", true) == 0 && objParamList.Count == 1)
            {
                EditPlayWaveStealthListener.Text = (string)objParamList[0];
                return;
            }

            if (String.Compare(sCommand, "GetCOMM", true) == 0 && objParamList.Count == 3)
            {
                EditListenIP.Text = (string)objParamList[0];
                EditListenPort.Text = (string)objParamList[1];
                EditDomainRealm.Text = (string)objParamList[2];
                return;
            }

            if (String.Compare(sCommand, "SetCOMM", true) == 0 && objParamList.Count == 3)
                return;

            if (String.Compare(sCommand, "StatusServerSIP", true) == 0 && objParamList.Count == 1)
            {
                string sStatus = (string)objParamList[0];
                LabelServerStatus.Text = sStatus.ToUpper();

                return;
            }

            if (String.Compare(sCommand, "GetCallCount", true) == 0 && objParamList.Count == 1)
            {
                LabelTotalCalls.Text = (string) objParamList[0];
                return;
            }

            if (String.Compare(sCommand, "GetUserCount", true) == 0 && objParamList.Count == 1)
            {
                LabelTotalUsers.Text = (string) objParamList[0];
                return;
            }

            if (String.Compare(sCommand, "GetUsageCPU", true) == 0 && objParamList.Count == 1)
            {
                LabelUsageCPU.Text = (string) objParamList[0];
                return;
            }

            if (String.Compare(sCommand, "GetAvailMEM", true) == 0 && objParamList.Count == 1)
            {
                LabelUsageMEM.Text = (string) objParamList[0];
                return;
            }
        }

        private void GeneralForm_Load(object sender, EventArgs e)
        {
            MainForm.m_objMainForm.SendCommand("GetHoldMusic");
            MainForm.m_objMainForm.SendCommand("GetDialToneMusic");
            MainForm.m_objMainForm.SendCommand("GetStealthMusic");

            MainForm.m_objMainForm.SendCommand("GetCOMM");
            MainForm.m_objMainForm.SendCommand("StatusServerSIP");

            MainForm.m_objMainForm.SendCommand("GetCallCount");
            MainForm.m_objMainForm.SendCommand("GetUserCount");
            MainForm.m_objMainForm.SendCommand("GetUsageCPU");
            MainForm.m_objMainForm.SendCommand("GetAvailMEM");

            TimerGeneral.Enabled = true;
        }

        private void BtnStartServerSIP_Click(object sender, EventArgs e)
        {
            ArrayList objParamList = new ArrayList();

            objParamList.Add(EditPlayWaveHold.Text);
            MainForm.m_objMainForm.SendCommand("SetHoldMusic", ref objParamList);

            objParamList.Clear();
            objParamList.Add(EditPlayWaveDialTone.Text);
            MainForm.m_objMainForm.SendCommand("SetDialToneMusic", ref objParamList);

            objParamList.Clear();
            objParamList.Add(EditPlayWaveStealthListener.Text);
            MainForm.m_objMainForm.SendCommand("SetStealthMusic", ref objParamList);

            objParamList.Clear();
            objParamList.Add(EditListenIP.Text);
            objParamList.Add(EditListenPort.Text);
            objParamList.Add(EditDomainRealm.Text);

            MainForm.m_objMainForm.SendCommand("SetCOMM", ref objParamList);
            MainForm.m_objMainForm.SendCommand("ServerStart");

        }

        private void BtnStopServerSIP_Click(object sender, EventArgs e)
        {
            MainForm.m_objMainForm.SendCommand("ServerStop");
        }

        private void TimerGeneral_Tick(object sender, EventArgs e)
        {
            MainForm.m_objMainForm.SendCommand("GetCallCount");
            MainForm.m_objMainForm.SendCommand("GetUserCount");
            MainForm.m_objMainForm.SendCommand("GetUsageCPU");
            MainForm.m_objMainForm.SendCommand("GetAvailMEM");
        }

        
    }
}